searchNodes=[{"ref":"Ueberauth.Strategy.EVESSO.html","title":"Ueberauth.Strategy.EVESSO","type":"module","doc":"Provides an Ueberauth strategy for authenticating with EVE SSO v2. Setup Create an SSO Application on the EVE Developers page. After registering an application get the client id and secret key from the application details page. Include the credentials in the configuration for EVESSO config :ueberauth, Ueberauth.Strategy.EVESSO.OAuth, client_id: System.get_env(&quot;EVESSO_CLIENT_ID&quot;), client_secret: System.get_env(&quot;EVESSO_SECRET_KEY&quot;) If you haven&#39;t already, create a pipeline and set up routes for your callback handler pipeline :auth do Ueberauth.plug &quot;/auth&quot; end scope &quot;/auth&quot; do pipe_through [:browser, :auth] get &quot;/:provider/callback&quot;, AuthController, :callback end Create an endpoint for the callback where you will handle the Ueberauth.Auth struct defmodule MyApp.AuthController do use MyApp.Web, :controller def callback_phase(%{assigns: %{ueberauth_failure: fails}} = conn, _params) do #do things with the failure end def callback_phase(%{assigns: %{ueberauth_auth: auth}} = conn, params) do # do things with the auth end end You can edit the behaviour of the Strategy by including some options when you register your provider To set the uid_field config :ueberauth, Ueberauth, providers: [ evesso: {Ueberauth.Strategy.EVESSO, [uid_field: :character_id]} ] Default is :owner_hash, others available are :character_id and :name To set the default scopes: config :ueberauth, Ueberauth, providers: [ evesso: {Ueberauth.Strategy.EVESSO, [default_scope: &quot;esi-clones.read_implants.v1 esi-characters.read_notifications.v1&quot;]} ] Default is empty (&quot;&quot;) which doesn&#39;t grant any extra permissions beyond public endpoints but enables you to verify character ownership. Scopes are provided as a space-separated list."},{"ref":"Ueberauth.Strategy.EVESSO.html#auth/1","title":"Ueberauth.Strategy.EVESSO.auth/1","type":"function","doc":""},{"ref":"Ueberauth.Strategy.EVESSO.html#credentials/1","title":"Ueberauth.Strategy.EVESSO.credentials/1","type":"function","doc":"Includes the credentials from the SSO response."},{"ref":"Ueberauth.Strategy.EVESSO.html#default_options/0","title":"Ueberauth.Strategy.EVESSO.default_options/0","type":"function","doc":""},{"ref":"Ueberauth.Strategy.EVESSO.html#extra/1","title":"Ueberauth.Strategy.EVESSO.extra/1","type":"function","doc":"Stores the raw information, including the token, obtained from the SSO callback."},{"ref":"Ueberauth.Strategy.EVESSO.html#handle_callback!/1","title":"Ueberauth.Strategy.EVESSO.handle_callback!/1","type":"function","doc":"Handles failure of SSO where no auth code is returned"},{"ref":"Ueberauth.Strategy.EVESSO.html#handle_cleanup!/1","title":"Ueberauth.Strategy.EVESSO.handle_cleanup!/1","type":"function","doc":"Cleans up the private area of the connection used for passing the raw SSO response around during the callback phase"},{"ref":"Ueberauth.Strategy.EVESSO.html#handle_request!/1","title":"Ueberauth.Strategy.EVESSO.handle_request!/1","type":"function","doc":"Handles the initial redirect to the EVE SSO authentication page To customize the scopes that are requested from SSO include them as part of your url: &quot;/auth/evesso?scope=esi-clones.read_implants.v1&quot; EVE SSO v2 also requires a state param that will be returned and can be used to guard against MITM attacks."},{"ref":"Ueberauth.Strategy.EVESSO.html#info/1","title":"Ueberauth.Strategy.EVESSO.info/1","type":"function","doc":"Fetches the fields to populate the info section of the Ueberauth.Auth struct."},{"ref":"Ueberauth.Strategy.EVESSO.html#uid/1","title":"Ueberauth.Strategy.EVESSO.uid/1","type":"function","doc":"Fetches the uid field from the token payload. This defaults to the option uid_field which in turn defaults to owner_hash"},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html","title":"Ueberauth.Strategy.EVESSO.OAuth","type":"module","doc":"An implementation of OAuth2 for EVE SSO To add your client_id and client_secret include these values in your configuration. config :ueberauth, Ueberauth.Strategy.EVESSO.OAuth, client_id: System.get_env(&quot;EVESSO_CLIENT_ID&quot;), client_secret: System.get_env(&quot;EVESSO_SECRET_KEY&quot;)"},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#authorize_url/2","title":"Ueberauth.Strategy.EVESSO.OAuth.authorize_url/2","type":"function","doc":"Builds the URL to the authorization endpoint. Example def authorize_url(client, params) do client |&gt; put_param(:response_type, &quot;code&quot;) |&gt; put_param(:client_id, client.client_id) |&gt; put_param(:redirect_uri, client.redirect_uri) |&gt; merge_params(params) end Callback implementation for OAuth2.Strategy.authorize_url/2."},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#authorize_url!/2","title":"Ueberauth.Strategy.EVESSO.OAuth.authorize_url!/2","type":"function","doc":"Provides the authorize url for the request phase of Ueberauth. No need to call this directly usually."},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#client/1","title":"Ueberauth.Strategy.EVESSO.OAuth.client/1","type":"function","doc":"Construct a client for requests to EVE SSO Optionally include any OAuth2 options here to be merged with the defaults. Ueberauth.Strategy.EVESSO.OAuth.client(redired_uri: &quot;http://localhost:4000/auth/evesso/callback&quot;) This will be set up automatically for you in Ueberauth.Strategy.EVESSO. These options are only useful for usage outside the normal callback phase of Ueberauth."},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#get/4","title":"Ueberauth.Strategy.EVESSO.OAuth.get/4","type":"function","doc":""},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#get_token/3","title":"Ueberauth.Strategy.EVESSO.OAuth.get_token/3","type":"function","doc":"Builds the URL to the token endpoint. Example def get_token(client, params, headers) do client |&gt; put_param(:code, params[:code]) |&gt; put_param(:grant_type, &quot;authorization_code&quot;) |&gt; put_param(:client_id, client.client_id) |&gt; put_param(:client_secret, client.client_secret) |&gt; put_param(:redirect_uri, client.redirect_uri) |&gt; merge_params(params) |&gt; put_headers(headers) end Callback implementation for OAuth2.Strategy.get_token/3."},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#get_token!/2","title":"Ueberauth.Strategy.EVESSO.OAuth.get_token!/2","type":"function","doc":""},{"ref":"Ueberauth.Strategy.EVESSO.OAuth.html#verify/1","title":"Ueberauth.Strategy.EVESSO.OAuth.verify/1","type":"function","doc":"Decodes the JWT locally and retrieves the user information held within. More work could be done here to actually validate the token, see ESI docs for details"},{"ref":"readme.html","title":"Überauth EVE SSO","type":"extras","doc":"Überauth EVE SSO EVE SSO OAuth2 strategy for Überauth"},{"ref":"readme.html#installation","title":"Überauth EVE SSO - Installation","type":"extras","doc":"Setup your application at the EVE third party developer page. Add :ueberauth_eve_sso to your list of dependencies in mix.exs: def deps do [{:ueberauth_github, &quot;~&gt; 0.1}] end Add the strategy to your applications: def application do [applications: [:ueberauth_eve_sso]] end Add EVESSO to your ueberauth configuration: config :ueberauth, Ueberauth, providers: [ evesso: {Ueberauth.Strategy.EVESSO, []} ] Update your provider configuration: config :ueberauth, Ueberauth.Strategy.EVESSO.OAuth, client_id: System.get_env(&quot;EVESSO_CLIENT_ID&quot;), client_secret: System.get_env(&quot;EVESSO_SECRET_KEY&quot;) Or, to read the client credentials at runtime: config :ueberauth, Ueberauth.Strategy.EVESSO.OAuth, client_id: {:system, &quot;EVESSO_CLIENT_ID&quot;}, client_secret: {:system, &quot;EVESSO_SECRET_KEY&quot;} Include the Ueberauth plug in your controller: defmodule MyApp.AuthController do use MyApp.Web, :controller pipeline :browser do plug Ueberauth ... end end Create the request and callback routes if you haven&#39;t already: scope &quot;/auth&quot;, MyApp do pipe_through :browser get &quot;/:provider&quot;, AuthController, :request get &quot;/:provider/callback&quot;, AuthController, :callback end Your controller needs to implement callbacks to deal with Ueberauth.Auth and Ueberauth.Failure responses."},{"ref":"readme.html#calling","title":"Überauth EVE SSO - Calling","type":"extras","doc":"Depending on the configured url you can initiate the request through: /auth/evesso Or with options: /auth/evesso?scope=esi-clones.read_implants.v1&amp;state=nonce By default the requested scope is empty (&quot;&quot;). This allows access to all public endpoints and identifies the EVE Character. Scope can be configured either explicitly as a scope query value on the request path or in your configuration: ```elixir config :ueberauth, Ueberauth, providers: [ evesso: {Ueberauth.Strategy.EVESSO, [default_scope: &quot;esi-clones.read_implants.v1&quot;]} ] The state param is required by EVE SSO and should be a nonce generated for each request."},{"ref":"readme.html#license","title":"Überauth EVE SSO - License","type":"extras","doc":"Please see LICENSE for licensing details."}]